import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import clsx from 'clsx';
import Grid from "@material-ui/core/esm/Grid";
import List from "@material-ui/core/esm/List";
import ListItem from "@material-ui/core/esm/ListItem";
import ListItemText from "@material-ui/core/esm/ListItemText";
import ListItemIcon from "@material-ui/core/esm/ListItemIcon";
import Checkbox from "@material-ui/core/esm/Checkbox";
import ListItemSecondaryAction from "@material-ui/core/esm/ListItemSecondaryAction";
import IconButton from "@material-ui/core/esm/IconButton";
import FormControl from "@material-ui/core/esm/FormControl";
import FormLabel from "@material-ui/core/esm/FormLabel";
import FormHelperText from "@material-ui/core/esm/FormHelperText";
import Toolbar from "@material-ui/core/esm/Toolbar";
import TextField from "@material-ui/core/esm/TextField";
import Typography from "@material-ui/core/esm/Typography";
import ChevronRightIcon from '@material-ui/icons/ChevronRight';
import ChevronLeftIcon from '@material-ui/icons/ChevronLeft';
import DoubleArrowIcon from '@material-ui/icons/DoubleArrow';
import SortIcon from '@material-ui/icons/ArrowUpward';
import { makeStyles } from '@material-ui/core/styles';
import DualListSelectCommon from '@data-driven-forms/common/dual-list-select';
import FormFieldGrid from '../form-field-grid/form-field-grid';
import { validationError } from '../validation-error/validation-error';
var useStyles = makeStyles(function () {
  return {
    allToLeftIcon: {
      transform: 'scaleX(-1)'
    },
    upsideDown: {
      transform: 'scaleY(-1)'
    },
    list: {
      height: 300,
      overflow: 'auto'
    },
    button: {
      display: 'flex',
      justifyContent: 'center'
    },
    buttonsGrid: {
      height: '100%',
      alignContent: 'center'
    },
    filter: {
      width: '100%'
    },
    toolbar: {
      paddingLeft: 16,
      paddingRight: 16
    }
  };
});

var ListInternal = function ListInternal(_ref) {
  var value = _ref.value,
      optionClick = _ref.optionClick,
      noOptionsTitle = _ref.noOptionsTitle,
      filterValue = _ref.filterValue,
      filterValueText = _ref.filterValueText,
      selectedValues = _ref.selectedValues,
      ListProps = _ref.ListProps,
      ListItemProps = _ref.ListItemProps,
      ListItemIconProps = _ref.ListItemIconProps,
      ListItemTextProps = _ref.ListItemTextProps,
      ListItemSecondaryActionProps = _ref.ListItemSecondaryActionProps,
      checkboxVariant = _ref.checkboxVariant;
  var classes = useStyles();
  return /*#__PURE__*/React.createElement(List, _extends({
    component: "nav"
  }, ListProps, {
    className: clsx(classes.list, ListProps.className)
  }), value.length < 1 && /*#__PURE__*/React.createElement(ListItem, _extends({
    button: true,
    disabled: true
  }, ListItemProps), /*#__PURE__*/React.createElement(ListItemText, {
    primary: filterValue ? filterValueText : noOptionsTitle
  })), value.length > 0 && value.map(function (_ref2) {
    var value = _ref2.value,
        label = _ref2.label,
        icon = _ref2.icon,
        isCheckbox = _ref2.isCheckbox,
        secondaryActions = _ref2.secondaryActions,
        ListItemPropsItem = _ref2.ListItemProps,
        ListItemIconPropsItem = _ref2.ListItemIconProps,
        ListItemTextPropsItem = _ref2.ListItemTextProps,
        ListItemSecondaryActionPropsItem = _ref2.ListItemSecondaryActionProps;
    return /*#__PURE__*/React.createElement(ListItem, _extends({
      button: true,
      key: value,
      selected: selectedValues.includes(value),
      onClick: function onClick(e) {
        return optionClick(isCheckbox || checkboxVariant ? _objectSpread(_objectSpread({}, e), {}, {
          ctrlKey: true
        }) : e, value);
      }
    }, ListItemProps, ListItemPropsItem), (icon || isCheckbox || checkboxVariant) && /*#__PURE__*/React.createElement(ListItemIcon, _extends({}, ListItemIconProps, ListItemIconPropsItem), isCheckbox || checkboxVariant ? /*#__PURE__*/React.createElement(Checkbox, {
      edge: "start",
      checked: selectedValues.includes(value),
      tabIndex: -1,
      disableRipple: true
    }) : icon), /*#__PURE__*/React.createElement(ListItemText, _extends({
      primary: label
    }, ListItemTextProps, ListItemTextPropsItem)), secondaryActions && /*#__PURE__*/React.createElement(ListItemSecondaryAction, _extends({}, ListItemSecondaryActionProps, ListItemSecondaryActionPropsItem), secondaryActions));
  }));
};

ListInternal.propTypes = {
  value: PropTypes.arrayOf(PropTypes.shape({
    value: PropTypes.string.isRequired,
    label: PropTypes.string.isRequired
  })),
  optionClick: PropTypes.func.isRequired,
  noOptionsTitle: PropTypes.node,
  filterValue: PropTypes.string,
  filterValueText: PropTypes.node,
  selectedValues: PropTypes.array,
  checkboxVariant: PropTypes.bool,
  ListProps: PropTypes.object,
  ListItemProps: PropTypes.object,
  ListItemIconProps: PropTypes.object,
  ListItemTextProps: PropTypes.object,
  ListItemSecondaryActionProps: PropTypes.object
};
ListInternal.defaultProps = {
  value: [],
  ListProps: {}
};

var ToolbarInternal = function ToolbarInternal(_ref3) {
  var ToolbarProps = _ref3.ToolbarProps,
      LeftToolbarProps = _ref3.LeftToolbarProps,
      filterOptions = _ref3.filterOptions,
      filterOptionsTitle = _ref3.filterOptionsTitle,
      FilterFieldProps = _ref3.FilterFieldProps,
      sortOptions = _ref3.sortOptions,
      SortIconButtonProps = _ref3.SortIconButtonProps,
      SortIconProps = _ref3.SortIconProps,
      LeftSortIconProps = _ref3.LeftSortIconProps,
      LeftFilterFieldProps = _ref3.LeftFilterFieldProps,
      LeftSortIconButtonProps = _ref3.LeftSortIconButtonProps,
      filter = _ref3.filter,
      sortDesc = _ref3.sortDesc;
  var classes = useStyles();
  return /*#__PURE__*/React.createElement(Toolbar, _extends({
    variant: "dense"
  }, ToolbarProps, LeftToolbarProps, {
    className: clsx(classes.toolbar, ToolbarProps && ToolbarProps.className, LeftToolbarProps && LeftToolbarProps.className)
  }), /*#__PURE__*/React.createElement(TextField, _extends({
    edge: "start",
    id: "options-search",
    label: filterOptionsTitle,
    onChange: function onChange(_ref4) {
      var value = _ref4.target.value;
      return filterOptions(value);
    },
    value: filter,
    type: "search"
  }, FilterFieldProps, LeftFilterFieldProps, {
    className: clsx(classes.filter, FilterFieldProps && FilterFieldProps.className, LeftFilterFieldProps && LeftFilterFieldProps.className)
  })), /*#__PURE__*/React.createElement(IconButton, _extends({
    "aria-label": "sort options",
    edge: "end",
    onClick: sortOptions,
    color: "inherit"
  }, SortIconButtonProps, LeftSortIconButtonProps), /*#__PURE__*/React.createElement(SortIcon, _extends({}, SortIconProps, LeftSortIconProps, {
    className: clsx(!sortDesc && classes.upsideDown, SortIconProps && SortIconProps.className, LeftSortIconProps && LeftSortIconProps.className)
  }))));
};

ToolbarInternal.propTypes = {
  ToolbarProps: PropTypes.object,
  LeftToolbarProps: PropTypes.object,
  filterOptions: PropTypes.func,
  filterOptionsTitle: PropTypes.node,
  state: PropTypes.object,
  FilterFieldProps: PropTypes.object,
  sortOptions: PropTypes.func,
  SortIconButtonProps: PropTypes.object,
  SortIconProps: PropTypes.object,
  LeftSortIconProps: PropTypes.object,
  LeftFilterFieldProps: PropTypes.object,
  LeftSortIconButtonProps: PropTypes.object,
  filter: PropTypes.string,
  sortDesc: PropTypes.bool
};

var DualListSelect = function DualListSelect(_ref5) {
  var handleOptionsClick = _ref5.handleOptionsClick,
      rightValues = _ref5.rightValues,
      noValueTitle = _ref5.noValueTitle,
      filterValueText = _ref5.filterValueText,
      leftValues = _ref5.leftValues,
      noOptionsTitle = _ref5.noOptionsTitle,
      state = _ref5.state,
      filterOptionsText = _ref5.filterOptionsText,
      handleValuesClick = _ref5.handleValuesClick,
      handleMoveRight = _ref5.handleMoveRight,
      moveRightTitle = _ref5.moveRightTitle,
      handleClearLeftValues = _ref5.handleClearLeftValues,
      moveAllRightTitle = _ref5.moveAllRightTitle,
      handleClearRightValues = _ref5.handleClearRightValues,
      moveAllLeftTitle = _ref5.moveAllLeftTitle,
      handleMoveLeft = _ref5.handleMoveLeft,
      moveLeftTitle = _ref5.moveLeftTitle,
      allToRight = _ref5.allToRight,
      allToLeft = _ref5.allToLeft,
      checkboxVariant = _ref5.checkboxVariant,
      isRequired = _ref5.isRequired,
      meta = _ref5.meta,
      validateOnMount = _ref5.validateOnMount,
      label = _ref5.label,
      helperText = _ref5.helperText,
      description = _ref5.description,
      filterOptionsTitle = _ref5.filterOptionsTitle,
      leftTitle = _ref5.leftTitle,
      filterOptions = _ref5.filterOptions,
      sortOptions = _ref5.sortOptions,
      sortValues = _ref5.sortValues,
      filterValueTitle = _ref5.filterValueTitle,
      filterValues = _ref5.filterValues,
      rightTitle = _ref5.rightTitle,
      FormFieldGridProps = _ref5.FormFieldGridProps,
      InternalGridProps = _ref5.InternalGridProps,
      ListGridProps = _ref5.ListGridProps,
      LeftListGridProps = _ref5.LeftListGridProps,
      ListProps = _ref5.ListProps,
      LeftListProps = _ref5.LeftListProps,
      ButtonsGridProps = _ref5.ButtonsGridProps,
      ButtonsInternalGridProps = _ref5.ButtonsInternalGridProps,
      ButtonGridProps = _ref5.ButtonGridProps,
      ToRightGridProps = _ref5.ToRightGridProps,
      IconButtonProps = _ref5.IconButtonProps,
      ToRightIconButtonProps = _ref5.ToRightIconButtonProps,
      IconProps = _ref5.IconProps,
      AllToLeftIconProps = _ref5.AllToLeftIconProps,
      AllToRightGridProps = _ref5.AllToRightGridProps,
      AllToRightIconButtonProps = _ref5.AllToRightIconButtonProps,
      AllToLeftGridProps = _ref5.AllToLeftGridProps,
      AllToLeftIconButtonProps = _ref5.AllToLeftIconButtonProps,
      ToLeftGridProps = _ref5.ToLeftGridProps,
      ToLeftIconProps = _ref5.ToLeftIconProps,
      ToLeftIconButtonProps = _ref5.ToLeftIconButtonProps,
      RightListGridProps = _ref5.RightListGridProps,
      RightListProps = _ref5.RightListProps,
      ListItemProps = _ref5.ListItemProps,
      ListItemIconProps = _ref5.ListItemIconProps,
      ListItemTextProps = _ref5.ListItemTextProps,
      ListItemSecondaryActionProps = _ref5.ListItemSecondaryActionProps,
      LeftListItemProps = _ref5.LeftListItemProps,
      LeftListItemIconProps = _ref5.LeftListItemIconProps,
      LeftItemTextProps = _ref5.LeftItemTextProps,
      LeftItemSecondaryActionProps = _ref5.LeftItemSecondaryActionProps,
      RightListItemProps = _ref5.RightListItemProps,
      RightListItemIconProps = _ref5.RightListItemIconProps,
      RightItemTextProps = _ref5.RightItemTextProps,
      RightItemSecondaryActionProps = _ref5.RightItemSecondaryActionProps,
      FormControlProps = _ref5.FormControlProps,
      FormLabelProps = _ref5.FormLabelProps,
      FormHelperTextProps = _ref5.FormHelperTextProps,
      TitleProps = _ref5.TitleProps,
      ToolbarProps = _ref5.ToolbarProps,
      FilterFieldProps = _ref5.FilterFieldProps,
      SortIconButtonProps = _ref5.SortIconButtonProps,
      SortIconProps = _ref5.SortIconProps,
      LeftToolbarProps = _ref5.LeftToolbarProps,
      LeftFilterFieldProps = _ref5.LeftFilterFieldProps,
      LeftSortIconButtonProps = _ref5.LeftSortIconButtonProps,
      LeftSortIconProps = _ref5.LeftSortIconProps,
      LeftTitleProps = _ref5.LeftTitleProps,
      RightToolbarProps = _ref5.RightToolbarProps,
      RightFilterFieldProps = _ref5.RightFilterFieldProps,
      RightSortIconButtonProps = _ref5.RightSortIconButtonProps,
      RightSortIconProps = _ref5.RightSortIconProps,
      RightTitleProps = _ref5.RightTitleProps;
  var classes = useStyles();
  var invalid = validationError(meta, validateOnMount);
  var text = invalid || (meta.touched || validateOnMount) && meta.warning || helperText || description;
  return /*#__PURE__*/React.createElement(FormFieldGrid, FormFieldGridProps, /*#__PURE__*/React.createElement(FormControl, _extends({
    fullWidth: true,
    required: isRequired,
    error: !!invalid,
    component: "fieldset"
  }, FormControlProps), /*#__PURE__*/React.createElement(FormLabel, _extends({
    component: "legend"
  }, FormLabelProps), label), /*#__PURE__*/React.createElement(Grid, _extends({
    container: true
  }, InternalGridProps), /*#__PURE__*/React.createElement(Grid, _extends({
    item: true,
    xs: 12,
    md: 5
  }, ListGridProps, LeftListGridProps), leftTitle && /*#__PURE__*/React.createElement(Typography, _extends({
    variant: "h6",
    gutterBottom: true
  }, TitleProps, LeftTitleProps), leftTitle), /*#__PURE__*/React.createElement(ToolbarInternal, {
    ToolbarProps: ToolbarProps,
    LeftToolbarProps: LeftToolbarProps,
    filterOptions: filterOptions,
    filterOptionsTitle: filterOptionsTitle,
    FilterFieldProps: FilterFieldProps,
    sortOptions: sortOptions,
    SortIconButtonProps: SortIconButtonProps,
    SortIconProps: SortIconProps,
    LeftSortIconProps: LeftSortIconProps,
    LeftFilterFieldProps: LeftFilterFieldProps,
    LeftSortIconButtonProps: LeftSortIconButtonProps,
    filter: state.filterOptions,
    sortDesc: state.sortLeftDesc
  }), /*#__PURE__*/React.createElement(ListInternal, {
    optionClick: handleOptionsClick,
    value: leftValues,
    noOptionsTitle: noOptionsTitle,
    filterValue: state.filterOptions,
    filterValueText: filterOptionsText,
    selectedValues: state.selectedLeftValues,
    checkboxVariant: checkboxVariant,
    ListProps: _objectSpread(_objectSpread({}, ListProps), LeftListProps),
    ListItemProps: _objectSpread(_objectSpread({}, ListItemProps), LeftListItemProps),
    ListItemIconProps: _objectSpread(_objectSpread({}, ListItemIconProps), LeftListItemIconProps),
    ListItemTextProps: _objectSpread(_objectSpread({}, ListItemTextProps), LeftItemTextProps),
    ListItemSecondaryActionProps: _objectSpread(_objectSpread({}, ListItemSecondaryActionProps), LeftItemSecondaryActionProps)
  })), /*#__PURE__*/React.createElement(Grid, _extends({
    item: true,
    xs: 12,
    md: 2
  }, ButtonsGridProps), /*#__PURE__*/React.createElement(Grid, _extends({
    container: true
  }, ButtonsInternalGridProps, {
    className: clsx(classes.buttonsGrid, ButtonsInternalGridProps && ButtonsInternalGridProps.className)
  }), /*#__PURE__*/React.createElement(Grid, _extends({
    item: true,
    md: 12,
    sm: 3
  }, ButtonGridProps, ToRightGridProps, {
    className: clsx(classes.button, ButtonGridProps && ButtonGridProps.className, ToRightGridProps && ToRightGridProps.className)
  }), /*#__PURE__*/React.createElement(IconButton, _extends({
    disabled: leftValues.length === 0,
    onClick: handleMoveRight,
    title: moveRightTitle
  }, IconButtonProps, ToRightIconButtonProps), /*#__PURE__*/React.createElement(ChevronRightIcon, _extends({}, IconProps, AllToLeftIconProps)))), allToRight && /*#__PURE__*/React.createElement(Grid, _extends({
    item: true,
    md: 12,
    sm: 3
  }, ButtonGridProps, AllToRightGridProps, {
    className: clsx(classes.button, ButtonGridProps && ButtonGridProps.className, AllToRightGridProps && AllToRightGridProps.className)
  }), /*#__PURE__*/React.createElement(IconButton, _extends({
    disabled: leftValues.length === 0,
    onClick: handleClearLeftValues,
    title: moveAllRightTitle
  }, IconButtonProps, AllToRightIconButtonProps), /*#__PURE__*/React.createElement(DoubleArrowIcon, _extends({}, IconProps, AllToLeftIconProps)))), allToLeft && /*#__PURE__*/React.createElement(Grid, _extends({
    item: true,
    md: 12,
    sm: 3
  }, ButtonGridProps, AllToLeftGridProps, {
    className: clsx(classes.button, ButtonGridProps && ButtonGridProps.className, AllToLeftGridProps && AllToLeftGridProps.className)
  }), /*#__PURE__*/React.createElement(IconButton, _extends({
    disabled: rightValues.length === 0,
    onClick: handleClearRightValues,
    title: moveAllLeftTitle
  }, IconButtonProps, AllToLeftIconButtonProps), /*#__PURE__*/React.createElement(DoubleArrowIcon, _extends({
    className: classes.allToLeftIcon
  }, IconProps, AllToLeftIconProps)))), /*#__PURE__*/React.createElement(Grid, _extends({
    item: true,
    md: 12,
    sm: 3
  }, ButtonGridProps, ToLeftGridProps, {
    className: clsx(classes.button, ButtonGridProps && ButtonGridProps.className, ToLeftGridProps && ToLeftGridProps.className)
  }), /*#__PURE__*/React.createElement(IconButton, _extends({
    disabled: rightValues.length === 0,
    onClick: handleMoveLeft,
    title: moveLeftTitle
  }, IconButtonProps, ToLeftIconButtonProps), /*#__PURE__*/React.createElement(ChevronLeftIcon, _extends({}, IconProps, ToLeftIconProps)))))), /*#__PURE__*/React.createElement(Grid, _extends({
    item: true,
    xs: 12,
    md: 5
  }, ListGridProps, RightListGridProps), rightTitle && /*#__PURE__*/React.createElement(Typography, _extends({
    variant: "h6",
    gutterBottom: true
  }, TitleProps, RightTitleProps), rightTitle), /*#__PURE__*/React.createElement(ToolbarInternal, {
    ToolbarProps: ToolbarProps,
    LeftToolbarProps: RightToolbarProps,
    filterOptions: filterValues,
    filterOptionsTitle: filterValueTitle,
    FilterFieldProps: FilterFieldProps,
    sortOptions: sortValues,
    SortIconButtonProps: SortIconButtonProps,
    SortIconProps: SortIconProps,
    LeftSortIconProps: RightSortIconProps,
    LeftFilterFieldProps: RightFilterFieldProps,
    LeftSortIconButtonProps: RightSortIconButtonProps,
    filter: state.filterValue,
    sortDesc: state.sortRightDesc
  }), /*#__PURE__*/React.createElement(ListInternal, {
    checkboxVariant: checkboxVariant,
    optionClick: handleValuesClick,
    value: rightValues,
    noOptionsTitle: noValueTitle,
    filterValue: state.filterValue,
    filterValueText: filterValueText,
    selectedValues: state.selectedRightValues,
    ListProps: _objectSpread(_objectSpread({}, ListProps), RightListProps),
    ListItemProps: _objectSpread(_objectSpread({}, ListItemProps), RightListItemProps),
    ListItemIconProps: _objectSpread(_objectSpread({}, ListItemIconProps), RightListItemIconProps),
    ListItemTextProps: _objectSpread(_objectSpread({}, ListItemTextProps), RightItemTextProps),
    ListItemSecondaryActionProps: _objectSpread(_objectSpread({}, ListItemSecondaryActionProps), RightItemSecondaryActionProps)
  }))), text && /*#__PURE__*/React.createElement(FormHelperText, FormHelperTextProps, text)));
};

DualListSelect.propTypes = {
  leftTitle: PropTypes.node,
  rightTitle: PropTypes.node,
  moveLeftTitle: PropTypes.node,
  moveRightTitle: PropTypes.node,
  allToLeft: PropTypes.bool,
  allToRight: PropTypes.bool,
  checkboxVariant: PropTypes.bool,
  validateOnMount: PropTypes.bool,
  moveAllLeftTitle: PropTypes.node,
  moveAllRightTitle: PropTypes.node,
  label: PropTypes.node,
  isRequired: PropTypes.bool,
  helperText: PropTypes.node,
  noValueTitle: PropTypes.node,
  noOptionsTitle: PropTypes.node,
  filterOptionsTitle: PropTypes.node,
  filterValueTitle: PropTypes.node,
  filterValueText: PropTypes.node,
  filterOptionsText: PropTypes.node,
  description: PropTypes.node,
  hideLabel: PropTypes.bool,
  id: PropTypes.string,
  input: PropTypes.shape({
    name: PropTypes.string.isRequired
  }),
  meta: PropTypes.any,
  state: PropTypes.object,
  sortOptions: PropTypes.func,
  filterOptions: PropTypes.func,
  handleOptionsClick: PropTypes.func,
  leftValues: PropTypes.array,
  handleMoveRight: PropTypes.func,
  handleMoveLeft: PropTypes.func,
  handleClearLeftValues: PropTypes.func,
  handleClearRightValues: PropTypes.func,
  sortValues: PropTypes.func,
  filterValues: PropTypes.func,
  rightValues: PropTypes.array,
  handleValuesClick: PropTypes.func,
  // props
  FormFieldGridProps: PropTypes.object,
  InternalGridProps: PropTypes.object,
  ListGridProps: PropTypes.object,
  LeftListGridProps: PropTypes.object,
  ListProps: PropTypes.object,
  LeftListProps: PropTypes.object,
  ButtonsGridProps: PropTypes.object,
  ButtonsInternalGridProps: PropTypes.object,
  ButtonGridProps: PropTypes.object,
  ToRightGridProps: PropTypes.object,
  IconButtonProps: PropTypes.object,
  ToRightIconButtonProps: PropTypes.object,
  IconProps: PropTypes.object,
  AllToLeftIconProps: PropTypes.object,
  AllToRightGridProps: PropTypes.object,
  AllToRightIconButtonProps: PropTypes.object,
  AllToLeftGridProps: PropTypes.object,
  AllToLeftIconButtonProps: PropTypes.object,
  ToLeftGridProps: PropTypes.object,
  ToLeftIconProps: PropTypes.object,
  ToLeftIconButtonProps: PropTypes.object,
  RightListGridProps: PropTypes.object,
  RightListProps: PropTypes.object,
  ListItemProps: PropTypes.object,
  ListItemIconProps: PropTypes.object,
  ListItemTextProps: PropTypes.object,
  ListItemSecondaryActionProps: PropTypes.object,
  LeftListItemProps: PropTypes.object,
  LeftListItemIconProps: PropTypes.object,
  LeftItemTextProps: PropTypes.object,
  LeftItemSecondaryActionProps: PropTypes.object,
  RightListItemProps: PropTypes.object,
  RightListItemIconProps: PropTypes.object,
  RightItemTextProps: PropTypes.object,
  RightItemSecondaryActionProps: PropTypes.object,
  FormControlProps: PropTypes.object,
  FormLabelProps: PropTypes.object,
  FormHelperTextProps: PropTypes.object,
  TitleProps: PropTypes.object,
  ToolbarProps: PropTypes.object,
  FilterFieldProps: PropTypes.object,
  SortIconButtonProps: PropTypes.object,
  SortIconProps: PropTypes.object,
  LeftToolbarProps: PropTypes.object,
  LeftFilterFieldProps: PropTypes.object,
  LeftSortIconButtonProps: PropTypes.object,
  LeftSortIconProps: PropTypes.object,
  LeftTitleProps: PropTypes.object,
  RightToolbarProps: PropTypes.object,
  RightFilterFieldProps: PropTypes.object,
  RightSortIconButtonProps: PropTypes.object,
  RightSortIconProps: PropTypes.object,
  RightTitleProps: PropTypes.object
};
DualListSelect.defaultProps = {
  leftTitle: 'Options',
  rightTitle: 'Selected',
  moveLeftTitle: 'Move selected to left',
  moveRightTitle: 'Move selected to right',
  moveAllRightTitle: 'Move all to right',
  moveAllLeftTitle: 'Move all to left',
  noOptionsTitle: 'No available options',
  noValueTitle: 'No selected',
  filterOptionsTitle: 'Filter options',
  filterValueTitle: 'Filter selected value',
  filterOptionsText: 'Remove your filter to see all options',
  filterValueText: 'Remove your filter to see all selected',
  options: [],
  allToLeft: true,
  allToRight: true
};

var DualListSelectWrapper = function DualListSelectWrapper(props) {
  return /*#__PURE__*/React.createElement(DualListSelectCommon, _extends({}, props, {
    DualListSelect: DualListSelect
  }));
};

export default DualListSelectWrapper;