"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.reducer = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFormApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _fieldArray = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/field-array"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _styles = require("@material-ui/core/styles");

var _Redo = _interopRequireDefault(require("@material-ui/icons/Redo"));

var _Undo = _interopRequireDefault(require("@material-ui/icons/Undo"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _clsx = _interopRequireDefault(require("clsx"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useFielArrayStyles = (0, _styles.makeStyles)({
  formControl: {
    width: '100%'
  },
  centerText: {
    display: 'flex',
    justifyContent: 'center'
  },
  buttonsToEnd: {
    display: 'flex',
    justifyContent: 'flex-end'
  },
  header: {
    display: 'flex'
  },
  label: {
    flexGrow: 1
  },
  fieldArrayGroup: {
    marginBottom: 32
  }
});

var ArrayItem = function ArrayItem(_ref) {
  var fields = _ref.fields,
      fieldIndex = _ref.fieldIndex,
      name = _ref.name,
      remove = _ref.remove,
      length = _ref.length,
      minItems = _ref.minItems,
      removeLabel = _ref.removeLabel,
      FieldContainerProps = _ref.FieldContainerProps,
      FieldGroupGridProps = _ref.FieldGroupGridProps,
      RemoveButtonGridProps = _ref.RemoveButtonGridProps,
      RemoveButtonProps = _ref.RemoveButtonProps;

  var _useFormApi = (0, _useFormApi2["default"])(),
      renderForm = _useFormApi.renderForm;

  var classes = useFielArrayStyles();
  var editedFields = fields.map(function (field, index) {
    var computedName = field.name ? "".concat(name, ".").concat(field.name) : name;
    return _objectSpread(_objectSpread({}, field), {}, {
      name: computedName,
      key: "".concat(computedName, "-").concat(index)
    });
  });
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    container: true,
    spacing: 3
  }, FieldContainerProps), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, FieldGroupGridProps), /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
    container: true,
    spacing: 3
  }, renderForm([editedFields]))), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12,
    className: classes.buttonsToEnd
  }, RemoveButtonGridProps), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    color: "secondary",
    onClick: function onClick() {
      return remove(fieldIndex);
    },
    disabled: length <= minItems
  }, RemoveButtonProps), removeLabel)));
};

ArrayItem.propTypes = {
  name: _propTypes["default"].string,
  fieldIndex: _propTypes["default"].number.isRequired,
  fields: _propTypes["default"].arrayOf(_propTypes["default"].object),
  remove: _propTypes["default"].func.isRequired,
  length: _propTypes["default"].number,
  minItems: _propTypes["default"].number,
  removeLabel: _propTypes["default"].node.isRequired,
  FieldContainerProps: _propTypes["default"].object,
  FieldGroupGridProps: _propTypes["default"].object,
  RemoveButtonGridProps: _propTypes["default"].object,
  RemoveButtonProps: _propTypes["default"].object
};
ArrayItem.defaultProps = {
  FieldContainerProps: {},
  FieldGroupGridProps: {},
  RemoveButtonGridProps: {},
  RemoveButtonProps: {}
};
var defaultButtonLabels = {
  add: 'ADD',
  remove: 'REMOVE'
};
var initialState = {
  index: 0,
  history: []
};

var reducer = function reducer(state, _ref2) {
  var type = _ref2.type,
      action = _ref2.action;

  switch (type) {
    case 'redo':
      return _objectSpread(_objectSpread({}, state), {}, {
        index: state.index + 1
      });

    case 'action':
      return {
        index: state.index + 1,
        history: [].concat((0, _toConsumableArray2["default"])(state.history.slice(0, state.index)), [action])
      };

    case 'undo':
      return _objectSpread(_objectSpread({}, state), {}, {
        index: state.index - 1
      });

    case 'resetHistory':
      return _objectSpread(_objectSpread({}, state), {}, {
        history: state.history.slice(0, state.index)
      });

    default:
      return state;
  }
};

exports.reducer = reducer;

var DynamicArray = function DynamicArray(_ref3) {
  var props = (0, _extends2["default"])({}, _ref3);

  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      arrayValidator = _useFieldApi.arrayValidator,
      label = _useFieldApi.label,
      description = _useFieldApi.description,
      formFields = _useFieldApi.fields,
      defaultItem = _useFieldApi.defaultItem,
      meta = _useFieldApi.meta,
      minItems = _useFieldApi.minItems,
      maxItems = _useFieldApi.maxItems,
      noItemsMessage = _useFieldApi.noItemsMessage,
      FormFieldGridProps = _useFieldApi.FormFieldGridProps,
      FormControlProps = _useFieldApi.FormControlProps,
      buttonLabels = _useFieldApi.buttonLabels,
      GridContainerProps = _useFieldApi.GridContainerProps,
      HeaderGridProps = _useFieldApi.HeaderGridProps,
      HeaderProps = _useFieldApi.HeaderProps,
      UndoButtonProps = _useFieldApi.UndoButtonProps,
      RedoButtonProps = _useFieldApi.RedoButtonProps,
      AddButtonProps = _useFieldApi.AddButtonProps,
      DescriptionGridProps = _useFieldApi.DescriptionGridProps,
      DescriptionProps = _useFieldApi.DescriptionProps,
      BodyGridProps = _useFieldApi.BodyGridProps,
      NoItemsProps = _useFieldApi.NoItemsProps,
      FormHelperTextGridProps = _useFieldApi.FormHelperTextGridProps,
      FormHelperTextProps = _useFieldApi.FormHelperTextProps,
      FieldContainerProps = _useFieldApi.FieldContainerProps,
      FieldGroupGridProps = _useFieldApi.FieldGroupGridProps,
      RemoveButtonGridProps = _useFieldApi.RemoveButtonGridProps,
      RemoveButtonProps = _useFieldApi.RemoveButtonProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["arrayValidator", "label", "description", "fields", "defaultItem", "meta", "minItems", "maxItems", "noItemsMessage", "FormFieldGridProps", "FormControlProps", "buttonLabels", "GridContainerProps", "HeaderGridProps", "HeaderProps", "UndoButtonProps", "RedoButtonProps", "AddButtonProps", "DescriptionGridProps", "DescriptionProps", "BodyGridProps", "NoItemsProps", "FormHelperTextGridProps", "FormHelperTextProps", "FieldContainerProps", "FieldGroupGridProps", "RemoveButtonGridProps", "RemoveButtonProps"]);

  var _useReducer = (0, _react.useReducer)(reducer, initialState),
      _useReducer2 = (0, _slicedToArray2["default"])(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var combinedButtonLabels = _objectSpread(_objectSpread({}, defaultButtonLabels), buttonLabels);

  var classes = useFielArrayStyles();
  var dirty = meta.dirty,
      submitFailed = meta.submitFailed,
      error = meta.error,
      submitError = meta.submitError;
  var isError = (dirty || submitFailed) && error && typeof error === 'string';
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], (0, _extends2["default"])({}, FormFieldGridProps, {
    className: (0, _clsx["default"])(classes.fieldArrayGroup, FormFieldGridProps.classname)
  }), /*#__PURE__*/_react["default"].createElement(_FormControl["default"], (0, _extends2["default"])({
    component: "fieldset",
    error: isError || submitError
  }, FormControlProps, {
    className: (0, _clsx["default"])(classes.formControl, FormControlProps.className)
  }), /*#__PURE__*/_react["default"].createElement(_fieldArray["default"], {
    key: rest.input.name,
    name: rest.input.name,
    validate: arrayValidator
  }, function (_ref4) {
    var _ref4$fields = _ref4.fields,
        map = _ref4$fields.map,
        _ref4$fields$value = _ref4$fields.value,
        value = _ref4$fields$value === void 0 ? [] : _ref4$fields$value,
        push = _ref4$fields.push,
        remove = _ref4$fields.remove;

    var pushWrapper = function pushWrapper() {
      dispatch({
        type: 'resetHistory'
      });
      push(defaultItem);
    };

    var removeWrapper = function removeWrapper(index) {
      dispatch({
        type: 'action',
        action: {
          action: 'remove',
          value: value[index]
        }
      });
      remove(index);
    };

    var undo = function undo() {
      push(state.history[state.index - 1].value);
      dispatch({
        type: 'undo'
      });
    };

    var redo = function redo() {
      remove(value.length - 1);
      dispatch({
        type: 'redo'
      });
    };

    return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
      container: true,
      spacing: 3
    }, GridContainerProps), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
      item: true,
      xs: 12,
      className: classes.header
    }, HeaderGridProps), label && /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
      variant: "h6",
      className: classes.label
    }, HeaderProps), label), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], (0, _extends2["default"])({
      color: "primary",
      "aria-label": "undo",
      component: "span",
      disabled: state.index === 0,
      onClick: undo
    }, UndoButtonProps), /*#__PURE__*/_react["default"].createElement(_Undo["default"], null)), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], (0, _extends2["default"])({
      color: "primary",
      "aria-label": "redo",
      component: "span",
      disabled: state.index === state.history.length,
      onClick: redo
    }, RedoButtonProps), /*#__PURE__*/_react["default"].createElement(_Redo["default"], null)), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
      color: "primary",
      onClick: pushWrapper,
      disabled: value.length >= maxItems
    }, AddButtonProps), combinedButtonLabels.add)), description && /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
      item: true,
      xs: 12
    }, DescriptionGridProps), /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
      variant: "subtitle1"
    }, DescriptionProps), description)), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
      item: true,
      xs: 12
    }, BodyGridProps), value.length <= 0 ? /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
      variant: "body1",
      gutterBottom: true,
      className: classes.centerText
    }, NoItemsProps), noItemsMessage) : map(function (name, index) {
      return /*#__PURE__*/_react["default"].createElement(ArrayItem, {
        key: name,
        fields: formFields,
        name: name,
        fieldIndex: index,
        remove: removeWrapper,
        length: value.length,
        minItems: minItems,
        removeLabel: combinedButtonLabels.remove,
        FieldContainerProps: FieldContainerProps,
        FieldGroupGridProps: FieldGroupGridProps,
        RemoveButtonGridProps: RemoveButtonGridProps,
        RemoveButtonProps: RemoveButtonProps
      });
    })), (isError || submitError) && /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
      item: true,
      xs: 12
    }, FormHelperTextGridProps), /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], FormHelperTextProps, error || submitError)));
  })));
};

DynamicArray.propTypes = {
  label: _propTypes["default"].node,
  description: _propTypes["default"].node,
  fields: _propTypes["default"].arrayOf(_propTypes["default"].object).isRequired,
  defaultItem: _propTypes["default"].any,
  minItems: _propTypes["default"].number,
  maxItems: _propTypes["default"].number,
  noItemsMessage: _propTypes["default"].node,
  FormControlProps: _propTypes["default"].object,
  FormFieldGridProps: _propTypes["default"].object,
  buttonLabels: _propTypes["default"].object,
  GridContainerProps: _propTypes["default"].object,
  HeaderGridProps: _propTypes["default"].object,
  HeaderProps: _propTypes["default"].object,
  UndoButtonProps: _propTypes["default"].object,
  RedoButtonProps: _propTypes["default"].object,
  AddButtonProps: _propTypes["default"].object,
  DescriptionGridProps: _propTypes["default"].object,
  DescriptionProps: _propTypes["default"].object,
  BodyGridProps: _propTypes["default"].object,
  NoItemsProps: _propTypes["default"].object,
  FormHelperTextGridProps: _propTypes["default"].object,
  FormHelperTextProps: _propTypes["default"].object,
  FieldContainerProps: _propTypes["default"].object,
  FieldGroupGridProps: _propTypes["default"].object,
  RemoveButtonGridProps: _propTypes["default"].object,
  RemoveButtonProps: _propTypes["default"].object
};
DynamicArray.defaultProps = {
  maxItems: Infinity,
  minItems: 0,
  noItemsMessage: 'No items added',
  FormControlProps: {},
  FormFieldGridProps: {},
  GridContainerProps: {},
  HeaderGridProps: {},
  HeaderProps: {},
  UndoButtonProps: {},
  RedoButtonProps: {},
  AddButtonProps: {},
  DescriptionGridProps: {},
  DescriptionProps: {},
  BodyGridProps: {},
  NoItemsProps: {},
  FormHelperTextGridProps: {},
  FormHelperTextProps: {},
  FieldContainerProps: {},
  FieldGroupGridProps: {},
  RemoveButtonGridProps: {},
  RemoveButtonProps: {}
};
var _default = DynamicArray;
exports["default"] = _default;