"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Grid = _interopRequireDefault(require("@material-ui/core/Grid"));

var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

var _FormLabel = _interopRequireDefault(require("@material-ui/core/FormLabel"));

var _FormGroup = _interopRequireDefault(require("@material-ui/core/FormGroup"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _multipleChoiceList = _interopRequireWildcard(require("@data-driven-forms/common/multiple-choice-list"));

var _validationError = require("../validation-error/validation-error");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var CheckboxContext = (0, _react.createContext)({});

var FinalCheckbox = function FinalCheckbox(_ref) {
  var label = _ref.label,
      _isDisabled = _ref.isDisabled,
      rest = (0, _objectWithoutProperties2["default"])(_ref, ["label", "isDisabled"]);

  var _useContext = (0, _react.useContext)(CheckboxContext),
      FormControlLabelProps = _useContext.FormControlLabelProps,
      CheckboxProps = _useContext.CheckboxProps,
      _useContext$props = _useContext.props,
      isRequired = _useContext$props.isRequired,
      isReadOnly = _useContext$props.isReadOnly,
      helperText = _useContext$props.helperText,
      validate = _useContext$props.validate,
      isDisabled = _useContext$props.isDisabled,
      props = (0, _objectWithoutProperties2["default"])(_useContext$props, ["isRequired", "isReadOnly", "helperText", "validate", "isDisabled"]);

  return /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], (0, _extends2["default"])({}, FormControlLabelProps, {
    control: /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], (0, _extends2["default"])({}, rest, props, CheckboxProps, {
      disabled: isDisabled
    }), label),
    label: label
  }));
};

FinalCheckbox.propTypes = {
  isDisabled: _propTypes["default"].bool,
  label: _propTypes["default"].node
};

var Wrapper = function Wrapper(_ref2) {
  var label = _ref2.label,
      isRequired = _ref2.isRequired,
      children = _ref2.children,
      meta = _ref2.meta,
      validateOnMount = _ref2.validateOnMount,
      helperText = _ref2.helperText,
      description = _ref2.description;
  var invalid = (0, _validationError.validationError)(meta, validateOnMount);

  var _useContext2 = (0, _react.useContext)(CheckboxContext),
      FormFieldGridProps = _useContext2.FormFieldGridProps,
      FormControlProps = _useContext2.FormControlProps,
      FormLabelProps = _useContext2.FormLabelProps,
      FormGroupProps = _useContext2.FormGroupProps,
      FormHelperTextProps = _useContext2.FormHelperTextProps;

  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    container: true
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_FormControl["default"], (0, _extends2["default"])({
    required: isRequired,
    error: !!invalid,
    component: "fieldset"
  }, FormControlProps), /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], FormLabelProps, label), /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], FormGroupProps, children), (invalid || helperText || description) && /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], FormHelperTextProps, invalid || helperText || description)));
};

Wrapper.propTypes = _objectSpread({}, _multipleChoiceList.wrapperProps);

var MultipleChoiceList = function MultipleChoiceList(_ref3) {
  var FormControlProps = _ref3.FormControlProps,
      FormLabelProps = _ref3.FormLabelProps,
      FormGroupProps = _ref3.FormGroupProps,
      FormHelperTextProps = _ref3.FormHelperTextProps,
      FormFieldGridProps = _ref3.FormFieldGridProps,
      FormControlLabelProps = _ref3.FormControlLabelProps,
      CheckboxProps = _ref3.CheckboxProps,
      props = (0, _objectWithoutProperties2["default"])(_ref3, ["FormControlProps", "FormLabelProps", "FormGroupProps", "FormHelperTextProps", "FormFieldGridProps", "FormControlLabelProps", "CheckboxProps"]);
  return /*#__PURE__*/_react["default"].createElement(CheckboxContext.Provider, {
    value: {
      FormControlProps: FormControlProps,
      FormLabelProps: FormLabelProps,
      FormGroupProps: FormGroupProps,
      FormHelperTextProps: FormHelperTextProps,
      FormFieldGridProps: FormFieldGridProps,
      FormControlLabelProps: FormControlLabelProps,
      CheckboxProps: CheckboxProps,
      props: props
    }
  }, /*#__PURE__*/_react["default"].createElement(_multipleChoiceList["default"], (0, _extends2["default"])({}, props, {
    Wrapper: Wrapper,
    Checkbox: FinalCheckbox
  })));
};

MultipleChoiceList.propTypes = {
  input: _propTypes["default"].shape({
    name: _propTypes["default"].string.isRequired
  }),
  FormFieldGridProps: _propTypes["default"].object,
  FormControlProps: _propTypes["default"].object,
  FormGroupProps: _propTypes["default"].object,
  FormControlLabelProps: _propTypes["default"].object,
  CheckboxProps: _propTypes["default"].object,
  FormLabelProps: _propTypes["default"].object,
  FormHelperTextProps: _propTypes["default"].object
};
MultipleChoiceList.defaultProps = {
  FormFieldGridProps: {},
  FormControlProps: {},
  FormGroupProps: {},
  FormControlLabelProps: {},
  CheckboxProps: {},
  FormLabelProps: {},
  FormHelperTextProps: {}
};
var _default = MultipleChoiceList;
exports["default"] = _default;