"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Radio = _interopRequireDefault(require("@material-ui/core/Radio"));

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _FormLabel = _interopRequireDefault(require("@material-ui/core/FormLabel"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _multipleChoiceList = require("@data-driven-forms/common/multiple-choice-list");

var _styles = require("@material-ui/core/styles");

var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));

var _validationError = require("../validation-error/validation-error");

var _useFieldApi3 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useStyles = (0, _styles.makeStyles)(function () {
  return {
    grid: {
      '&:first-child': {
        marginTop: 8
      }
    }
  };
});

var RadioOption = function RadioOption(_ref) {
  var name = _ref.name,
      option = _ref.option,
      isDisabled = _ref.isDisabled,
      isReadOnly = _ref.isReadOnly,
      FormControlLabelProps = _ref.FormControlLabelProps,
      _ref$RadioProps = _ref.RadioProps,
      inputProps = _ref$RadioProps.inputProps,
      RadioProps = (0, _objectWithoutProperties2["default"])(_ref$RadioProps, ["inputProps"]),
      props = (0, _objectWithoutProperties2["default"])(_ref, ["name", "option", "isDisabled", "isReadOnly", "FormControlLabelProps", "RadioProps"]);

  var _useFieldApi = (0, _useFieldApi3["default"])({
    name: name,
    type: 'radio',
    value: option.value
  }),
      input = _useFieldApi.input;

  return /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], (0, _extends2["default"])({
    key: "".concat(name, "-").concat(option.value),
    control: /*#__PURE__*/_react["default"].createElement(_Radio["default"], (0, _extends2["default"])({}, input, {
      name: name,
      disabled: isDisabled || isReadOnly,
      onChange: function onChange() {
        return input.onChange(option.value);
      },
      inputProps: _objectSpread({
        readOnly: isReadOnly
      }, inputProps)
    }, RadioProps)),
    label: option.label
  }, FormControlLabelProps, props));
};

RadioOption.propTypes = {
  name: _propTypes["default"].string.isRequired,
  option: _propTypes["default"].shape({
    label: _propTypes["default"].node.isRequired,
    value: _propTypes["default"].any.isRequired
  }).isRequired,
  isReadOnly: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool,
  FormControlLabelProps: _propTypes["default"].object,
  RadioProps: _propTypes["default"].object
};

var Radio = function Radio(_ref2) {
  var name = _ref2.name,
      props = (0, _objectWithoutProperties2["default"])(_ref2, ["name"]);

  var _useFieldApi2 = (0, _useFieldApi3["default"])(_objectSpread(_objectSpread({}, props), {}, {
    name: name,
    type: 'radio'
  })),
      options = _useFieldApi2.options,
      isDisabled = _useFieldApi2.isDisabled,
      label = _useFieldApi2.label,
      isRequired = _useFieldApi2.isRequired,
      helperText = _useFieldApi2.helperText,
      description = _useFieldApi2.description,
      isReadOnly = _useFieldApi2.isReadOnly,
      meta = _useFieldApi2.meta,
      validateOnMount = _useFieldApi2.validateOnMount,
      FormFieldGridProps = _useFieldApi2.FormFieldGridProps,
      FormControlProps = _useFieldApi2.FormControlProps,
      FormLabelProps = _useFieldApi2.FormLabelProps,
      FormHelperTextProps = _useFieldApi2.FormHelperTextProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi2, ["options", "isDisabled", "label", "isRequired", "helperText", "description", "isReadOnly", "meta", "validateOnMount", "FormFieldGridProps", "FormControlProps", "FormLabelProps", "FormHelperTextProps"]);

  var classes = useStyles();
  var invalid = (0, _validationError.validationError)(meta, validateOnMount);
  var text = invalid || (meta.touched || validateOnMount) && meta.warning || helperText || description;
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], (0, _extends2["default"])({
    className: classes.grid
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_FormControl["default"], (0, _extends2["default"])({
    required: isRequired,
    error: !!invalid,
    component: "fieldset"
  }, FormControlProps), /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], (0, _extends2["default"])({
    component: "legend"
  }, FormLabelProps), label), options.map(function (option) {
    return /*#__PURE__*/_react["default"].createElement(RadioOption, (0, _extends2["default"])({
      key: option.value,
      name: name,
      option: option,
      isDisabled: isDisabled,
      isReadOnly: isReadOnly
    }, rest));
  }), text && /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], FormHelperTextProps, text)));
};

Radio.propTypes = _objectSpread(_objectSpread({}, _multipleChoiceList.wrapperProps), {}, {
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].any,
    label: _propTypes["default"].node
  })),
  label: _propTypes["default"].node.isRequired,
  isDisabled: _propTypes["default"].bool,
  description: _propTypes["default"].node,
  FormFieldGridProps: _propTypes["default"].object,
  FormControlProps: _propTypes["default"].object,
  FormControlLabelProps: _propTypes["default"].object,
  RadioProps: _propTypes["default"].object,
  FormLabelProps: _propTypes["default"].object,
  FormHelperTextProps: _propTypes["default"].object
});
Radio.defaultProps = {
  options: [],
  FormFieldGridProps: {},
  FormControlProps: {},
  FormControlLabelProps: {},
  RadioProps: {},
  FormLabelProps: {},
  FormHelperTextProps: {}
};
var _default = Radio;
exports["default"] = _default;